#!/usr/bin/perl

###########################################
#
# SDPMailingList Administrator Version 1.2
# Copyright 1999
# Michael B. Jones
# http://www.shindigproductions.com
#
###########################################
#
# COPYRIGHT NOTICE
# Copyright 1999 Shindig Productions
# All Rights Reserved
#
# This script can be used/modified free of charge as long as this header
# remains intact.  The script is presented "as-is" without any
# warranty, and the author is not liable for any loss or damages arising
# out of the use of or failure to use this script.  Redistributing/selling
# the code for this program without prior written consent is expressly forbidden.
#
###########################################

require "SDPMList.cfg";

##########
# Globals

$product = "SDPMailingList Administrator v.1.2";
$sdp_url = "http://wml.webservis.ru";
$copyright = "1999";

#############
# Parse form
    
   if ($ENV{'REQUEST_METHOD'} eq 'GET') {
       &error('request');
       exit;
   }

   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/<!--(.|\n)*-->//g;
      $value =~ s/<([^>]|\n)*>//g;
      $FORM{$name} = $value;
   }

##############
# Subroutines

if ($pass == 1) {
&check_passwd;
} 
&assign;
&sendmail;
exit;

#################
# Check Password

sub check_passwd {

    if ($FORM{'password'} ne $passwd) {
        &error('bad_pass');
        open (MAIL, "|$mailprog -t") || die $!;
            print MAIL "To: $email\n";
            print MAIL "From: $product\n";
            print MAIL "Subject: Password Failed\n";
            print MAIL "Someone just tried to send e-mail from the administration script, but they entered the wrong password. ";
            print MAIL "They were from $ENV{'REMOTE_ADDR'} and they tried the following password:\n";
            print MAIL "$FORM{'password'}\n\n";
            print MAIL "-" x 60 . "\n\n";
            print MAIL "This mail was processed by $product\n";
            print MAIL "Available for free at $sdp_url";
            close (MAIL);
        exit;
    }
}

###################
# Assign Variables

sub assign {

   if ($FORM{'subject'}) {
      $subject = "$FORM{'subject'}";
      $subject =~ s/"//g;
      $subject =~ s/<//g;
      $subject =~ s/>//g;
      $subject =~ s/\&//g;
   }

   if ($FORM{'message'}) {
      $message = "$FORM{'message'}";
      $message =~ s/"//g;
      $message =~ s/<//g;
      $message =~ s/>//g;
      $message =~ s/\&//g;
   }
}

############
# Send mail

sub sendmail {

    $count = 0;
    open(LIST, "<$basedir/$mailfile") || die $!;
    @list = <LIST>;
    reverse @list;
    close(LIST);

    foreach $line (@list) {
        chomp ($line);
        if ($line !~ /<!--update-->/) { 
            open (MAIL, "|$mailprog -t") || die $!;
            print MAIL "To: $line\n";
            print MAIL "From: $email\n";
            print MAIL "Subject: $subject\n";
            print MAIL "$header\n\n";
            print MAIL "$message\n\n";
            print MAIL "-" x 60 . "\n\n";
            print MAIL "$footer\n\n";
            print MAIL "-" x 60 . "\n\n";
            print MAIL "This mail was processed by $product\n";
            print MAIL "Available for free at $sdp_url";
            close (MAIL);
            $count++;
        }    
    }

print <<"END HTML";
Content-type: text/html

<html>
<head>
<title>Success: $count E-mail(s) Sent</title>
</head>
<$body>
<center><br><br>
<table border=0 width=70%>
<tr><td bgcolor="#ff0000">
<$title_font>Success: $count E-mail(s) Sent</font>
</td></tr>
<tr><td bgcolor="#0000ff">
<$text_font>
<center>Copyright &copy;$copyright <a href="$sdp_url">Shindig Productions</a>
</font></center>
</td></tr>
</table>
</center>
</body>
</html>
END HTML
exit;
}

##########
# Errors

sub error { 

    $error = $_[0];
    if ($error eq 'request') {
        print "Content-type: text/html\n\n";    
        print <<"END HTML";
<html>
<head>
<title>$product</title>
</head>
<$body>
<br><br>
<center><table border=0 width=70%>
<tr> 
<td bgcolor="#ff0000">
<center>
<$title_font>$product
</font></center>
</td></tr>
<tr><td bgcolor="#0000ff"> 
<center>
<$text_font>Copyright &copy;$copyright <a href="$sdp_url">Shindig Productions</a></font> 
</center>
</td></tr>
</table></center>
</body>
</html>
END HTML
    }
    elsif ($error eq 'bad_pass') {
        print <<"END HTML";
Content-type: text/html

<html>
<head>
<title>Error: Password Incorrect</title>
</head>
<$body>
<center><br><br>
<table border=0 width=70%>
<tr><td bgcolor="#ff0000">
<$title_font>Error: Password Incorrect</font>
</td></tr>
<tr><td bgcolor="#0000ff">
<$text_font>
You did not enter the correct password.  Your failed attempt has been logged and
sent to the site administrator.
<br><br>
<center>Copyright &copy;$copyright <a href="$sdp_url">Shindig Productions</a>
</font></center>
</td></tr>
</table>
</center>
</body>
</html>
END HTML
    }
}